<template>
  <radio-group class="app-radio-group" v-model="currentVal">                 
    <radio v-for="(_item,index) in items" :key = "index" :label="_item.value" :disabled="isDisabled || _item.disabled">
        <span>{{Object.is(codelistType,'STATIC') ? $t('codelist.'+tag+'.'+_item.value) : _item.text}}</span>
    </radio>
  </radio-group>
</template>
<script lang = 'ts'>
import { Component, Vue, Prop, Model,Watch } from 'vue-property-decorator';
import CodeListService from "@/codelist/codelist-service";

@Component({})
export default class AppRadioGroup extends Vue {
    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof AppRadioGroup
     */  
    public codeListService:CodeListService = new CodeListService();

    /**
     * 双向绑定值
     *
     * @type {*}
     * @memberof AppRadioGroup
     */
    @Model('change') item?: any;

    /**
     * 实际值
     *
     * @type {*}
     * @memberof AppRadioGroup
     */
    public value: any = null;

    /**
     * 代码表标识
     *
     * @type {string}
     * @memberof AppRadioGroup
     */
    @Prop() public tag?: string;

    /**
     * 代码表类型
     *
     * @type {string}
     * @memberof AppRadioGroup
     */
    @Prop() public codelistType?: string;

    /**
     * 传入表单数据
     *
     * @type {*}
     * @memberof AppRadioGroup
     */
    @Prop() public data?: any;

    /**
     * 属性类型
     *
     * @type {'string' | 'number'}
     * @memberof AppRadioGroup
     */
    @Prop({ default: 'string' })
    public valueType!: 'string' | 'number';

    /**
     * 监控值变化，根据属性类型强制转换
     *
     * @memberof AppRadioGroup
     */
    @Watch('item',{immediate:true,deep:true})
    public itemWatch(){
        this.readyValue();
    }

    /**
     * 获取值
     *
     * @memberof AppRadioGroup
     */
    get currentVal() {
        return this.item;
    }

    /**
     * 设置值
     *
     * @memberof AppRadioGroup
     */
    set currentVal(val: any) {
        this.$emit('change', val);
    }

    /**
     * 监听表单数据变化
     * 
     * @memberof AppRadioGroup
     */
    @Watch('data',{immediate:true,deep:true})
    public onDataChange(newVal: any, oldVal: any) {
        if(newVal){
            if(this.tag && this.codelistType == 'DYNAMIC'){
                // 公共参数处理
                let data: any = {};
                this.handlePublicParams(data);
                // 参数处理
                let _context = data.context;
                let _param = data.param;
                this.codeListService.getItems(this.tag,_context,_param).then((res:any) => {
                    this.formatCodeList(this.$util.deepCopy(res));
                }).catch((error:any)=>{
                    console.log(`----${this.tag}----${(this.$t('app.commonWords.codeNotExist') as string)}`);
                })
            }
        }
    }

    /**
     * 是否禁用
     *
     * @type {boolean}
     * @memberof AppRadioGroup
     */
    @Prop() public disabled?: boolean;

    /**
     * 局部上下文导航参数
     * 
     * @type {any}
     * @memberof AppRadioGroup
     */
    @Prop() public localContext!:any;

    /**
     * 局部导航参数
     * 
     * @type {any}
     * @memberof AppRadioGroup
     */
    @Prop() public localParam!:any;

    /**
     * 视图上下文
     *
     * @type {*}
     * @memberof AppRadioGroup
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppRadioGroup
     */
    @Prop() public viewparams!: any;

    /**
     * 属性名称
     *
     * @type {string}
     * @memberof AppRadioGroup
     */
    @Prop() name?: string;

    /**
     * 是否禁用
     *
     * @readonly
     * @memberof AppRadioGroup
     */
    get isDisabled() {
        if (this.disabled) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 代码表
     *
     * @type {any[]}
     * @memberof AppRadioGroup
     */
    public items: any[] = [];

    /**
     * 公共参数处理
     *
     * @param {*} arg
     * @returns
     * @memberof AppRadioGroup
     */
    public handlePublicParams(arg: any) {
        // 合并表单参数
        arg.param = this.viewparams ? JSON.parse(JSON.stringify(this.viewparams)) : {};
        arg.context = this.context ? JSON.parse(JSON.stringify(this.context)) : {};
        // 附加参数处理
        if (this.localContext && Object.keys(this.localContext).length >0) {
            let _context = this.$util.computedNavData(this.data,arg.context,arg.param,this.localContext);
            Object.assign(arg.context,_context);
        }
        if (this.localParam && Object.keys(this.localParam).length >0) {
            let _param = this.$util.computedNavData(this.data,arg.param,arg.param,this.localParam);
            Object.assign(arg.param,_param);
        }
    }

    /**
     * vue  生命周期
     *
     * @memberof AppRadioGroup
     */
    public created() {
        if(this.tag && this.codelistType == 'STATIC'){
            const items  = this.$store.getters.getCodeListItems(this.tag);
            this.formatCodeList(this.$util.deepCopy(items));
        }else if(this.tag && this.codelistType == 'DYNAMIC'){
            // 公共参数处理
            let data: any = {};
            this.handlePublicParams(data);
            // 参数处理
            let _context = data.context;
            let _param = data.param;
            this.codeListService.getItems(this.tag,_context,_param).then((res:any) => {
                this.formatCodeList(this.$util.deepCopy(res));
            }).catch((error:any)=>{
                console.log(`----${this.tag}----${(this.$t('app.commonWords.codeNotExist') as string)}`);
            })
        }
    }

    /**
     * 格式化代码表值类型
     *
     * @param {any[]} items
     * @returns
     * @memberof AppRadioGroup
     */
    protected formatCodeList(items: any[]): void {
        // 判断类型是否和属性一致
        let judge = false;
        this.items = [];
        try {
            items.forEach((item: any) => {
                const type = this.$util.typeOf(item.value);
                if (type !== this.valueType) {
                    judge = true;
                    if (type === 'number') {
                        item.value = item.value.toString();
                    } else {
                        if(type == "null") {
                            this.valueType == "number" ? item.value = 0 : item.value = '';
                        }else if (item.value.indexOf('.') === -1) {
                            item.value = parseInt(item.value);
                        } else {
                            item.value = parseFloat(item.value);
                        }
                    }
                }
                this.items.push(item);
            });
            if (judge) {
                console.warn(
                    `代码表「${this.tag}」值类型和属性类型不符，目前采用强制转换模式。请修正代码表值类型和属性类型匹配。`
                );
            }
        } catch (error) {
            console.warn(
                '代码表值类型和属性类型不符，目前采用强制转换模式。转换过程异常，请修正代码表值类型和属性类型匹配。'
            );
        }
    }

    /**
     * 准备值
     *
     * @memberof AppRadioGroup
     */
    public readyValue() {
        if (this.item == null) {
            this.value = null;
            return;
        }
        if (this.$util.typeOf(this.item) === this.valueType) {
            this.value = this.item;
        } else if (this.valueType === 'number') {
            if (this.item.indexOf('.') === -1) {
                this.value = parseInt(this.item);
            } else {
                this.value = parseFloat(this.item);
            }
        } else {
            this.value = this.item.toString();
        }
        this.$emit('change',this.value);
    }
}
</script>
<style lang="scss">
@import './app-radio-group.scss';
</style>